/* 
 * CSE142, 99 Winter
 * Homework 5
 * Valentine's Day
 *
 * Author:     Eric R. Stride
 * Student ID: 9824281
 * Section:    BG
 *
 * Greeting Card Designer (Ultimate version)
 *
 *  The GP142 graphics window shows some buttons and the inside
 *  or outside (cover) of a greeting card.  The idea is that you 
 *  can design what you want to card to look like by adding and moving
 *  objects: 
 *    messages, message color and position
 *    shapes,   shape color and position
 *
 *   To place a message or a greeting, you click on an appropriate button, and 
 *   then you can click on the desired position in the card.  
 
 */

#include "gp142.h"
#include <math.h>
#include <time.h>
    /* <time.h> is here only so that one function can be called
    to seed the random number generator.
    Put it here in your program and forget about it, 
    just in case you decide later you need to use random numbers.
    */

/*******************************************************************
*                           #DEFINE's                              *
********************************************************************/

#define TRUE            1
#define FALSE           0

/*
 * The state, or status you are in determines what happens when you click 
 * the card:
 * ADD SHAPE   -- you click the card, and a new object is placed there.
 *                You get into this mode by clicking an ADD button.
 *                After doing an ADD, you are put into SELECTED mode.
 * SELECTED    -- An object is selected. In this mode, the type 
 *                rotation applies to thecurrent object.
  */
/* Hint: you may need to add statuses when you make the program more complex.*/
#define STATUS_ADD_SHAPE 1
#define STATUS_SELECTED 2
#define STATUS_ADD_MESSAGE 3
#define STATUS_SELECTING 4
#define STATUS_CLEAR 5

/* Configure the appearance of the buttons on the menu bar 
 * by setting the number of pixels of button height and width
 */
#define BUTTON_HEIGHT   35
#define BUTTON_WIDTH    100

/*change this if you add or delete buttons*/
#define NUM_BUTTONS     9
#define SELECTED_COLOR  RED

/* Position of the card in the window */
#define PAGE_LLX (-GP142_XMAX + BUTTON_WIDTH +60)
#define PAGE_LLY (-GP142_YMAX + 100)
#define PAGE_WIDTH (GP142_XMAX - PAGE_LLX - 80)
#define PAGE_HEIGHT (GP142_YMAX - PAGE_LLY - 50)

/* For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn.
 */
#define FILL 0
#define NOFILL 1

/* Types of objects we support.  (Perhaps not all types are used yet.)*/
#define OBJECT_NONE 0
#define OBJECT_SHAPE 1
#define OBJECT_MESSAGE 2

/*if you add new types, you may need to change this*/
#define MAX_SHAPES 5
#define FIRST_SHAPE_NUM 0
#define MAX_MESSAGES 6
#define FIRST_MESSAGE_NUM 0
/* These are the kinds of shapes we support.*/
#define SHAPE_HEART 0
#define SHAPE_STAR  1
#define SHAPE_MAN 2
#define SHAPE_BUG 3
#define SHAPE_KENNY 4

/*These are the messages*/
#define MESS_0 0
#define MESS_1 1
#define MESS_2 2
#define MESS_3 3
#define MESS_4 4
#define MESS_5 5

/* Hint: once you understand how these shape types are used, you may decide
 * to do something similar with messages
 */

/*Possible places for mouse clicks*/
#define CLICK_BUTTON 1  /* You clicked on SOME button (doesn't say which one)*/
#define CLICK_CARD 2    /* You clicked in the card area */
#define CLICK_OUTSIDE 3 /* You clicked outside the card area, not on a button*/ 

/*array attributes*/
#define MAX_OBJ 51   /*maximum of 50 shapes and messages (starts at 1, not 0)*/
                    /*DANIEL:  It said at least 10 shapes and 10 messages, so I
                          decided to let them have at least 50 total, it will stop
                          giving you more after that many, I tested it */
/*DrawHeart */
#define HEART_WIDTH 35

/*DrawStar */
#define STARPOINTS 5
#define STARRADIUS 40
#define PI 3.1416

/*DrawStickMan */
#define HEAD_RAD 12
#define BODY_LEN 30
#define LEG_X 12
#define LEG_Y 15
#define ARM 9
#define ARM2 6
#define EYE_X 5
#define EYE_Y 4
#define EYE 2
#define MOUTH 4
#define MOUTH_Y 6
#define HAIR_LEN 5
#define MOUTH_CNST 3
#define MAN_CNST1 6
#define MAN_CNST2 4

/*DrawLoveBug */
#define BUGHEAD 12
#define BUGBODY 16
#define BUGANT 2
#define BUGANT_X 6  
#define BUGANT_Y 8
#define BUGEYE 3
#define BUGEYE_X 5
#define BUGEYE_Y 4
#define BUGLEG_X 20
#define BUGLEG_Y 9
#define BUGANT_CNST1 4
#define BUGANT_CNST2 11
#define BUGANT_CNST3 6
#define BUGLEG_CNST 6
#define BUGHEAD_OFFSET 4
#define BUGBODY_OFFSET 3
#define BUGSMILE_X1 7
#define BUGSMILE_Y1 9
#define BUGSMILE_XY 2

/*DrawKenny */
#define KENNYHEAD  25
#define KENNYHEAD1 15
#define KENNYHEAD_X 9
#define KENNYHEAD_Y 15
#define KENNYHEAD_OFF 9
#define KENNYEYE 4
#define KENNYEYE_X 6
#define KENNYEYE_Y 3
#define KENNYPUPIL 1
#define KENNYBODY_X 18
#define KENNYBODY_Y 35
#define KENNYBODY_OFF 3
#define KENNYHAND 5
#define KENNYHAND_Y 4
#define KENNYARM 13
#define KENNYARM_Y 2
#define KENNYBELT 3
#define KENNYFONT 10
#define K_ANI1 60
#define K_ANI2 100
#define K_ANI3 120
#define K_ANI4 135
#define K_EXP1 8
#define K_EXP2 9
#define K_EXP3 12
#define K_EXP4 15

/*DrawMessage */
#define MESS_CNST 4

/*CheckClose */
#define CLOSENESS 15.0



/*******************  FUNCTION PROTOTYPES **************************/

/* Drawing functions */
void DrawBlankScreen (int border_color);
void DrawButtons(int last_button);
void DrawCard (int background_color, int status, int object_count, 
               int object_type, int object_num, 
               int object_color, int object_x, int object_y,
               int obj_x[MAX_OBJ], int obj_y[MAX_OBJ], 
               int obj_color[MAX_OBJ], int obj_type[MAX_OBJ], 
               int obj_spec[MAX_OBJ], int *k_ani);
void DrawShape(int shape_type, int color, int bottom_x, int bottom_y, int *k_ani);
void DrawHeart (int x, int y, int color);
void DrawStar (int x, int y, int color);
void DrawStickMan(int x, int y, int color);
void DrawLoveBug (int x, int y, int color);
void DrawMessage(int spec, int color, int x, int y);
void DrawKenny (int x, int y, int color, int *k_ani);

/*checks the closeness of an object to coordinates clicked*/
int CheckClose (int x, int y, int xa[MAX_OBJ], 
                int ya[MAX_OBJ], int *object_count);



/* Mouse click handling functions */
void HandleMouseClick(int mouse_x, int mouse_y, int *background_color, 
                      int *status, int *object_count, int *object_type, 
                      int *object_num, int *object_color, 
                      int *object_x, int *object_y, int obj_x[MAX_OBJ],
                      int obj_y[MAX_OBJ], int obj_color[MAX_OBJ],
                      int obj_type[MAX_OBJ], int obj_spec[MAX_OBJ], 
                      int *last_button, int *border_color);
int ClassifyMouseClick(int mouse_x, int mouse_y);
void HandleButton(int x, int y, int *background_color, int *status,
                  int object_count, int object_type, int *object_num, int *object_color,
                  int obj_x[MAX_OBJ], int obj_y[MAX_OBJ], int obj_color[MAX_OBJ],
                  int obj_type[MAX_OBJ], int obj_spec[MAX_OBJ], int *last_button,
                  int *border_color);

/* Add a shape to the card. */
void AddShape(int x, int y, int *status, int *object_count, 
               int *object_type, int *object_num, int *object_color, 
               int *object_x, int *object_y, int obj_x[MAX_OBJ], 
               int obj_y[MAX_OBJ], int obj_color[MAX_OBJ],
               int obj_type[MAX_OBJ], int obj_spec[MAX_OBJ]);

/* swap values into different array positions*/
void swap_arr(int x, int obj_x[MAX_OBJ], int obj_y[MAX_OBJ], int obj_color[MAX_OBJ], 
              int obj_type[MAX_OBJ], int obj_spec[MAX_OBJ], int *object_count);

/*****************************************************************************

     MAIN

*****************************************************************************/

/* main() has two chief purposes: to contain the important variables and 
 *initialize them, and to contain the "event loop," which constantly looks 
 *to see if an event has happened, and then processes the event by calling 
 *an appropriate function. An example of an event is a mouse click.
 */
int main(void)
{
    int quit = FALSE;              /* becomes TRUE to exit program */
    int mouse_x, mouse_y;          /* coordinates of a mouse click */
    char key_hit;                  /* which key was hit            */
    
    
    /*variables and their default values*/
    int background_color = YELLOW;
    int status = STATUS_ADD_SHAPE;
    int border_color = GREEN;
    
    /* Each object will have a number telling what kind of object it is, a color,
     * and an x and y coordinate.  You'll need to make these into arrays so you
     * can support more than one object.
     */
    int object_count = 0;           /* How many objects on the page? */
    int object_type = OBJECT_NONE;  /* Can also be a shape           */
    int object_num;                 /* If type is shape, either 
                                       heart or star                 */
    int object_color;               /* Color of object               */
    int object_x;                   /* Position of object            */
    int object_y;
    
    int last_button = -1;           /* Keep track of the last button clicked.
                                       This would be usefull when highlighting
                                       the last button the user clicked */

    int event; /*the most recent GP142 event*/

    /*arrays for storing object attributes*/
    int obj_x[MAX_OBJ],      /* position of objects */
        obj_y[MAX_OBJ],      /* same */
        obj_color[MAX_OBJ],  /* color of objects */
        obj_type [MAX_OBJ],  /* type of object */
        obj_spec[MAX_OBJ];   /* specific object in the type */

    int k_ani = 0; /* special animation counter -- for a "cool" effect */

    time_t t; /*needed only when initializing a random number generator*/
    

    /*
     * INITIALIZATIONS
     */
    srand (time(&t));       /* Seed the random number generator. This is 
                               something you should do if you plan to use 
                               random numbers. Leave it here in your program 
                               and forget about it.*/
    

    /* These GP142 initializations don't need to be changed */
    GP142_open();           /* Open and init the GP142 Graphics Window      */
    GP142_show_text(0);     /* Hide the text window                         */
    GP142_logging(LOG_OFF); /* Change to LOG_ON if you want it.             */
    
    GP142_clear();          /* This will clear the window & paint it white. */
    GP142_animate(ANI_RUN); /* Enable periodic events                       */
    
    
    
    /*
     * The main event loop:
     * --- ---- ----- -----
     * wait for the next user action, such as a mouse click or keyboard
     * keypress, or a periodic update event (allowing us to display the
     * next frame of an animation -- not used directly in this program)
     * and call the appropriate function to handle it.  Repeat this until 
     * the user signals "quit".
     */
    while (!quit) {  /*this is the famous "event loop" */
        
        /*start by redrawing everything */
        DrawBlankScreen (border_color);
        DrawCard (background_color, status, object_count, 
                  object_type, object_num, object_color, object_x, object_y, 
                  obj_x, obj_y, obj_color, obj_type, obj_spec, &k_ani);
        DrawButtons(last_button);     /* Show the buttons...*/ 
        
        /*Wait for something to happen */
        event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);
        
        /* Something just happened.  Figure out what it was, and react 
           appropriately. */
        switch (event) {
        case GP142_QUIT:
            quit = TRUE;           /* set flag to terminate loop           */
            break;
            
        case GP142_KBD:  /*A key was pressed */
            /*not needed for this program. Use this if user will need to 
              hit a key. Note that scanf CANNOT be used with GP142.  If you 
              use this, the key character value is in variable "key_hit"*/
            break;
            
        case GP142_MOUSE:
            /* A mouse click has occurred. Call the mouse handler to 
               decide where the click was and react as needed. */
            HandleMouseClick(mouse_x, mouse_y, &background_color, &status, 
                             &object_count, &object_type, 
                             &object_num, &object_color, 
                             &object_x, &object_y, obj_x, obj_y, obj_color,
                             obj_type, obj_spec, &last_button, &border_color);          
            break;
            
        case GP142_PERIODIC:
            /*An events has occurred simply because some time has passed,*/
            /*not currently used in the program*/       
            break;

        default:
            
            break;
            
        }  /*end switch */
        
    }  /* end event loop */
    
    
    /*
     * WRAP-UP
     */
    GP142_close();         /* clean up and close graphics window   */
    
    return 0;
}  /*end main */

/*****************************************************************************

     FUNCTIONS

*****************************************************************************/
/* 
 * For a blank screen just draw a rectangle (of border_color) that covers the 
 * whole GP142 window.
 */
void DrawBlankScreen (border_color) {
    int font_size = 14;

    GP142_rectangleXY (border_color,
                    -GP142_XMAX, -GP142_YMAX,
                    GP142_XMAX, GP142_YMAX,
                    FILL);

} /*end DrawBlankScreen */


/********************************************************************* 
 * Draws the buttons 
 */
void DrawButtons(int last_button)
{
/* To add buttons, you'll need to change the #defined constant NUM_BUTTONS
 * and add messages to this array.  Although we haven't covered 2-D arrays
 * yet, you should be able to play with this enough to get it going.
 * Look at course packet, page N-25, for a similar example.
 */
    char b_labels [NUM_BUTTONS][25] = {
        "Background color",
            "Next, please",
                "Object Color",
                    "Add Message",
                        "Add Shape",
                            "Select Object",
                                "Clear Page",
                                    "Border Color",
                                        "Instructions"
    };
    
    int i, text_offset = -GP142_XMAX + 6, font_size = 12;
    int y, label_y;
    
    /* draw rectangles and labels for each button */
    for(i = 0; i < NUM_BUTTONS; i++) {
        y = GP142_YMAX - i * BUTTON_HEIGHT;
        
        GP142_rectangleXY(BLACK,
            -GP142_XMAX + 4,
            y - 2,
            -GP142_XMAX + BUTTON_WIDTH,
            y - BUTTON_HEIGHT - 2, 1);
        
        
        label_y = y - BUTTON_HEIGHT/2;
        
        if (i == last_button)
            GP142_printfXY(SELECTED_COLOR, text_offset, label_y, font_size, b_labels[i]);   
        else
            GP142_printfXY(BLACK, text_offset, label_y, font_size, b_labels[i]);    
    }   
}


/**********************************************************************
 * Render (draw) the page and all its contents.
 */
void DrawCard (int background_color, int status, int object_count, 
               int object_type, int object_num, 
               int object_color, int object_x, int object_y,
               int obj_x[MAX_OBJ], int obj_y[MAX_OBJ], 
               int obj_color[MAX_OBJ], int obj_type[MAX_OBJ], 
               int obj_spec[MAX_OBJ], int *k_ani)
{
    int font_size = 14, z=0;

    /*
     * Draw the background of the card.
     */
    GP142_rectangleXY (background_color,
        PAGE_LLX, PAGE_LLY,
        PAGE_LLX+ PAGE_WIDTH, PAGE_LLY+ PAGE_HEIGHT,
        FILL);

    /*
     * Print the title
     */
    GP142_printfXY(BLUE, PAGE_LLX - 10, PAGE_LLY + PAGE_HEIGHT +20, 20, 
        "CSE 142 Create-A-Card -");
    GP142_printfXY(FOREST_GREEN, PAGE_LLX + 200, PAGE_LLY + PAGE_HEIGHT +20, 20,
        "- Created by Eric R. Stride");


    /* 
     * Draw a shape on the card, if one currently exists.
     */
    if (object_count >= 1) {
        for (z = 1; z <= object_count; z++){
            if (obj_type[z] == OBJECT_SHAPE)  /*check if shape or message */
                DrawShape (obj_spec[z], obj_color[z], obj_x[z], obj_y[z], k_ani);
            if (obj_type[z] == OBJECT_MESSAGE)
                DrawMessage(obj_spec[z], obj_color[z], obj_x[z], obj_y[z]);
        }
    }
    
    /*
     * Write an appropriate status message below the background
     */
    switch (status) {
    case STATUS_ADD_SHAPE:
        GP142_printfXY (BLACK, PAGE_LLX, PAGE_LLY-40, font_size,
            "Click on the card to add a shape");
        break;
    case STATUS_SELECTED:
        GP142_printfXY (RED, PAGE_LLX, PAGE_LLY-40, font_size-3,
            "Object selected. Click button to change shape.");
        break;
    case STATUS_ADD_MESSAGE:
        GP142_printfXY(BLACK, PAGE_LLX, PAGE_LLY-40, font_size,
            "Click on the card to add a message");
        break;
    case STATUS_SELECTING:
        GP142_printfXY(BLACK, PAGE_LLX, PAGE_LLY-40, font_size-2, 
            "Click on the center of an object to select it or the");
        GP142_printfXY(BLACK, PAGE_LLX, PAGE_LLY-60, font_size -2, 
            "lower left corner of a line of text");
        break;
    case STATUS_CLEAR:
        GP142_printfXY(BLACK, PAGE_LLX, PAGE_LLY-40, font_size,
            "To Clear Workspace, click on it, Click on another button to cancel");
        break;
    default:
        GP142_printfXY (BLACK, PAGE_LLX, PAGE_LLY-40, font_size,
            "Status error -- notify programmer");
        break;
    } /*end switch */
    
    
} /*end DrawPage */


/**********************************************************************
 * Draw one shape.
 */
void DrawShape(int shape_type, int color, int bottom_x, int bottom_y, 
    int *k_ani) {

    switch ((shape_type - FIRST_SHAPE_NUM) % MAX_SHAPES) {
    case SHAPE_HEART:
        DrawHeart (bottom_x, bottom_y, color);
        break;
    case SHAPE_STAR:
        DrawStar (bottom_x, bottom_y, color);
        break;
    case SHAPE_MAN:
        DrawStickMan (bottom_x, bottom_y, color);
        break;
    case SHAPE_BUG:
        DrawLoveBug (bottom_x, bottom_y, color);
        break;
    case SHAPE_KENNY:
        DrawKenny (bottom_x, bottom_y, color, k_ani);
        break;
    default:
        /* Unknown shape selected */
        break;

    } /*end switch*/

}


/**********************************************************************
 * Draw a heart on the card. A heart will be made by two overlapping
 * circles and a triangle.
 *
 * The pulsation is caused by adding a small, random amount to the 
 * heart height each time this function is called.
 */
void DrawHeart (int x, int y, int color) {

    int h = (HEART_WIDTH/2) + (rand () %4);

    GP142_circleXY (color, x - h + 5, y, h);
    GP142_circleXY (color, x + h - 5, y, h);
    GP142_triangleXY (color, x- h*2 +5, y-5,
                        x + h*2 -5, y-5,
                        x, y - h*2 -5, FILL);

}


/**********************************************************************
 * Draw a star on the card.
 *
 * We make the star twinkle by selecting the number of points randomly.  Each 
 * time it is redrawn, it is slightly different than the time before, which 
 * makes it appear to pulsate,
 */
void DrawStar (int x, int y, int color) {

    int sp;
    double angle;
    int x1, y1;

    sp = STARPOINTS + (rand () %3);
    for (angle = 0.0; angle < 2 * PI; angle = angle + (2*PI)/sp) {
        x1 = (int) (cos (angle) * STARRADIUS);
        y1 = (int) (sin (angle) * STARRADIUS);
        GP142_lineXY (color, x+x1, y+y1, x-x1, y-y1, 1);

    }
}

/********************************************************************** 
 * Draw a Stick Man on the card.
 * 
 * The man's limbs move by changing the ends of the limbs randomly
 */

void DrawStickMan(int x, int y, int color)
{
    int x1, y1, x2, i, j, k, l, hair_y;
    
    GP142_lineXY (color, x, y, x, y - BODY_LEN, 1); /*draw body */
    GP142_circleXY (color, x, y + HEAD_RAD, HEAD_RAD); /*head*/
    GP142_circleXY (color+1, x + EYE_X, y + HEAD_RAD + EYE_Y, EYE); /*rt eye*/
    GP142_circleXY (color+1, x - EYE_X, y + HEAD_RAD + EYE_Y, EYE); /*left eye*/
    
    l = rand () % MOUTH_CNST; /* rand mouth size */
    
    GP142_circleXY (color+2, x, y + HEAD_RAD - MOUTH_Y, MOUTH - l); /*outer mouth */
    GP142_circleXY (color+3, x, y + HEAD_RAD - MOUTH_Y, MOUTH - l - 1); /*inner mouth */
    
    /* next couple of lines is for the guy's hair */
    hair_y = y + (2 * HEAD_RAD) + HAIR_LEN;
    GP142_lineXY (color, x, y + (2 * HEAD_RAD), x, hair_y, 1); /*middle */
    GP142_lineXY (color, x + HEAD_RAD - 1, y+HEAD_RAD, x+HEAD_RAD-1, hair_y, 1); /*right */
    GP142_lineXY (color, x - HEAD_RAD+1, y+HEAD_RAD, x-HEAD_RAD+1, hair_y, 1); /*left*/
    GP142_lineXY (color, x + (HEAD_RAD/2), y+(5*(HEAD_RAD/3)), x+(HEAD_RAD/2), hair_y, 1);
    GP142_lineXY (color, x - (HEAD_RAD/2), y+(5*(HEAD_RAD/3)), x-(HEAD_RAD/2), hair_y, 1);
    
    i = rand () % MAN_CNST1;
    k = rand () % MAN_CNST1;
    
    GP142_lineXY (color, x, y-BODY_LEN, x+LEG_X-i, y-BODY_LEN-LEG_Y-i, 1); /*right leg*/
    GP142_lineXY (color, x, y-BODY_LEN, x-LEG_X+k, y-BODY_LEN-LEG_Y-k, 1); /*left leg*/
    
    j = rand () % MAN_CNST2;  /* get random */
    y1 = y - (BODY_LEN /2);
    x1 = x + ARM - j; 
    x2 = x - ARM + j;
    
    GP142_lineXY (color, x, y1, x1, y1 + j, 1); /* right arm part 1 */
    GP142_lineXY (color, x1, y1 + j, x1, y1 + j + ARM2, 1); /*rt arm 2 */
    GP142_lineXY (color, x, y1, x2, y1 - j , 1); /*left arm 1 */
    GP142_lineXY (color, x2, y1 - j, x2, y1 - j - ARM2, 1); /* left arm 2*/

}

/**********************************************************************
 * Draws a Love Bug
 *
 * Animated legs/antennae by randomly changing the ends 
 * with only 4 legs
 */
void DrawLoveBug (int x, int y, int color)
{
    int x1, x2, x3, y3, x4, y4, x5, y5, x6, y6, x7, y7, x8, y8, x9, y9, 
        x10, y10, i, j, k ,l, m, n, p; /*local variables*/

    x1 = x - ((3 * BUGBODY) / 2) + BUGBODY_OFFSET; /* center of end body */
    x2 = x + BUGBODY + BUGHEAD - BUGHEAD_OFFSET; /*center of head*/
    x3 = x2 + BUGANT_CNST1; /*start of antennae */
    y3 = y + BUGANT_CNST2; /*same*/
    i = rand() % BUGANT_CNST3; /* random antennae movement */
    x4 = x3 + BUGANT_X - i; /* end of antennae */
    y4 = y3 + BUGANT_Y; /* same */
    
    GP142_circleXY (color, x, y, BUGBODY); /* draw mid body*/
    GP142_circleXY (color, x1, y, BUGBODY); /*draw end body */
    GP142_circleXY (color, x2, y, BUGHEAD); /*draw head */
    GP142_circleXY (color+2, x2+BUGEYE_X, y+BUGEYE_Y, BUGEYE); /*draw eye */
    GP142_lineXY (color, x3, y3, x4, y4, 1); /* draw antennae */
    GP142_circleXY (color, x4, y4, BUGANT); /* draw antennae end */

    GP142_lineXY ( color + 2, x2 + BUGSMILE_X1, y - BUGSMILE_Y1, 
        x2 + BUGSMILE_XY, y - BUGSMILE_XY, 1); /* smile*/

    j = rand () % BUGLEG_CNST; /*random leg movement */
    k = rand () % BUGLEG_CNST; /*same */
    l = rand () % BUGLEG_CNST; /* ditto */     /* used 4 different rand so legs */
    m = rand () % BUGLEG_CNST; /* ditto */     /* are all moving differently */
    
    x5 = x + BUGLEG_X - j; /*front leg end point */
    y5 = y - BUGBODY - BUGLEG_Y - j; /*same*/
    x6 = x + k; /* 2nd front leg end*/
    y6 = y - BUGBODY - BUGLEG_Y - k; /*same*/
    
    GP142_lineXY (color, x + 10, y - BUGBODY + 3, x5, y5, 1); /*draw front leg */
    GP142_lineXY (color, x + 10, y - BUGBODY + 3, x6, y6, 1); /*draw 2nd front leg */
    
    x7 = x1 + BUGLEG_X - l; /* 3rd leg end */
    y7 = y - BUGBODY - BUGLEG_Y - l; /*same */
    x8 = x1 + m; /* back leg end */
    y8 = y - BUGBODY - BUGLEG_Y -m; /* same */
    
    GP142_lineXY (color, x1 + 10, y - BUGBODY + 3, x7, y7, 1); /* draw middle leg */
    GP142_lineXY (color, x1 + 10, y - BUGBODY + 3, x8, y8, 1); /*draw 2nd middle leg*/
    
    n = rand() % BUGLEG_CNST; /* randomize the back leg movements */
    p = rand() % BUGLEG_CNST; /* same */

    x9 = x1 - n; /* 5th leg end coord. */
    y9 = y - BUGBODY - BUGLEG_Y - n; /* same */
    x10 = x1 - BUGLEG_X + p; /* back leg end point */
    y10 = y - BUGBODY - BUGLEG_Y - p; /* same */

    GP142_lineXY (color, x1 - 10, y - BUGBODY + 3, x9, y9, 1); /* 5th leg*/
    GP142_lineXY (color, x1 - 10, y - BUGBODY + 3, x10, y10, 1); /*back leg */


}


/**********************************************************************
 * DrawKenny
 *
 * A Kenny for all the South Park fans
 *
 */
void DrawKenny (int x, int y, int color, int *k_ani)
{
    int exp_col = 0; /*special "cool" color incrementor */
    int xn = 0; /* another "nice" thing */

    int c = rand() % KENNYEYE_Y,    /*randomize the eye movement*/
        d = rand() % KENNYEYE_Y,
        a = rand() % 2,
        b = rand() % 2;
    if (a == 1) c = c - (2 * c);  /* randomize if it is positive or*/
    if (b == 1) d = d - (2 * d);  /* negative */

    
    /*check status of "color" */
    if (color % 2 == 0) {
    
    *k_ani = 0; /*resets the kenny animation variable */

    /*draw the head*/
    GP142_circleXY(RED, x, y, KENNYHEAD);
    GP142_circleXY(BROWN, x, y, KENNYHEAD1);
    GP142_ovalXY(PEACH, x - KENNYHEAD_X, y + KENNYHEAD_Y, x + KENNYHEAD_X,
        y - KENNYHEAD_Y, FILL );
    GP142_circleXY(WHITE, x - KENNYEYE_X, y + KENNYEYE_Y, KENNYEYE);
    GP142_circleXY(WHITE, x + KENNYEYE_X, y + KENNYEYE_Y, KENNYEYE);

    
    GP142_circleXY(BLACK, x - KENNYEYE_X+c, y + KENNYEYE_Y+d, KENNYPUPIL);
    GP142_circleXY(BLACK, x + KENNYEYE_X+c, y + KENNYEYE_Y+d, KENNYPUPIL);

    /*Draw the body*/
    GP142_rectangleXY(RED, x - KENNYBODY_X, y - KENNYHEAD + KENNYHEAD_OFF,
        x + KENNYBODY_X, y - KENNYHEAD + KENNYHEAD_OFF - KENNYBODY_Y, FILL);
    GP142_lineXY(BLACK, x, y - KENNYHEAD, x, 
        y - KENNYHEAD + KENNYHEAD_OFF - KENNYBODY_Y, 1);
    GP142_rectangleXY(BLACK, x - KENNYBODY_X - KENNYBODY_OFF, 
        y - KENNYHEAD + KENNYHEAD_OFF - KENNYBODY_Y, x + KENNYBODY_X +
        KENNYBODY_OFF, y - KENNYHEAD + KENNYHEAD_OFF - KENNYBODY_Y -
        KENNYBODY_OFF, FILL);

    /*Draw arms and hands */
    GP142_circleXY (BROWN, x - KENNYBODY_X - (KENNYARM /2) -1 , 
        y - KENNYHEAD + KENNYHEAD_OFF - ( KENNYBODY_Y / 2) - KENNYARM_Y - KENNYHAND_Y,
        KENNYHAND);
    GP142_circleXY (BROWN, x + KENNYBODY_X + (KENNYARM /2) +1 , 
        y - KENNYHEAD + KENNYHEAD_OFF - ( KENNYBODY_Y / 2) - KENNYARM_Y - KENNYHAND_Y,
        KENNYHAND);
    GP142_triangleXY (RED, x - KENNYBODY_X, y - KENNYHEAD + KENNYHEAD_OFF, 
        x - KENNYBODY_X, 
        y - KENNYHEAD + KENNYHEAD_OFF - ( KENNYBODY_Y / 2) - KENNYARM_Y,
        x - KENNYBODY_X - KENNYARM, 
        y - KENNYHEAD + KENNYHEAD_OFF - ( KENNYBODY_Y / 2) - KENNYARM_Y, FILL);
    GP142_triangleXY (RED, x + KENNYBODY_X, y - KENNYHEAD + KENNYHEAD_OFF, 
        x + KENNYBODY_X, 
        y - KENNYHEAD + KENNYHEAD_OFF - ( KENNYBODY_Y / 2) - KENNYARM_Y,
        x + KENNYBODY_X + KENNYARM, 
        y - KENNYHEAD + KENNYHEAD_OFF - ( KENNYBODY_Y / 2) - KENNYARM_Y, FILL);
    GP142_lineXY (BLACK, x - KENNYBODY_X, y - KENNYHEAD, x - KENNYBODY_X,
        y - KENNYHEAD + KENNYHEAD_OFF - ( KENNYBODY_Y / 2) - KENNYARM_Y - 1 , 1);
    GP142_lineXY (BLACK, x + KENNYBODY_X, y - KENNYHEAD, x + KENNYBODY_X,
        y - KENNYHEAD + KENNYHEAD_OFF - ( KENNYBODY_Y / 2) - KENNYARM_Y - 1 , 1);

    /*Draw his belt */
    GP142_rectangleXY (BROWN, x - KENNYBODY_X, 
        y - KENNYHEAD + KENNYHEAD_OFF - (KENNYBODY_Y / 2) - (KENNYBELT/2), 
        x + KENNYBODY_X, 
        y - KENNYHEAD + KENNYHEAD_OFF - (KENNYBODY_Y / 2) - (3*KENNYBELT/2), FILL);

    /* give a little message */
    GP142_printfXY(BLUE, x - 3 * KENNYHEAD, y - 2 * KENNYBODY_Y, KENNYFONT,
        "Change my color... just click once...");

    }  /*end (color %2 == 0) section */

    if (color % 2 ==1) {  /* begin the "cool" part */
    (*k_ani)++; /*increment animation counter */
    
    if (*k_ani < K_ANI1){
            /* give a little message */
        GP142_printfXY(BLUE, x - KENNYHEAD, y - 2 * KENNYBODY_Y, KENNYFONT,
            "Wait...");}
    else if (*k_ani < K_ANI2){
            /* give a little message */
        GP142_printfXY(BLUE, x - KENNYHEAD, y - 2 * KENNYBODY_Y, KENNYFONT,
            "What the...");
        exp_col = 1; /* set the color add variable */
    }
    if (*k_ani >= K_ANI2) {
        if (*k_ani < K_ANI3) { /* change the head */
            /*draw the head beginning to explode*/
            GP142_circleXY(RED, x+c, y+d, KENNYHEAD);
            GP142_circleXY(BROWN, x+c, y+d, KENNYHEAD1);
            GP142_ovalXY(RED, x +c- KENNYHEAD_X, y +d+ KENNYHEAD_Y, x +c+ KENNYHEAD_X,
                y +d- KENNYHEAD_Y, FILL );
            GP142_circleXY(RED, x+c - KENNYEYE_X, y +d+ KENNYEYE_Y, KENNYEYE);
            GP142_circleXY(RED, x+c + KENNYEYE_X, y +d+ KENNYEYE_Y, KENNYEYE);

    
            GP142_circleXY(BLACK, x - KENNYEYE_X+c, y + KENNYEYE_Y+d, KENNYPUPIL);
            GP142_circleXY(BLACK, x + KENNYEYE_X+c, y + KENNYEYE_Y+d, KENNYPUPIL);
        }
        else if (*k_ani < K_ANI4) { /* change the head */
            xn = 2 * (*k_ani - K_ANI3);
            
            /*draw the head exploding*/
            GP142_circleXY(RED, x, y + K_EXP3+xn, K_EXP3);
            GP142_circleXY(RED, x, y - K_EXP3-xn, K_EXP3);
            GP142_circleXY(RED, x + K_EXP3+xn, y, K_EXP3);
            GP142_circleXY(RED, x - K_EXP3-xn, y, K_EXP3);
            GP142_circleXY(RED, x + K_EXP1+xn, y + K_EXP2+xn, K_EXP3);
            GP142_circleXY(RED, x + K_EXP1+xn, y - K_EXP2-xn, K_EXP3);
            GP142_circleXY(RED, x - K_EXP1-xn, y + K_EXP2+xn, K_EXP3);
            GP142_circleXY(RED, x - K_EXP1-xn, y - K_EXP2-xn, K_EXP3);
        }



    /* draw lumps where his head used to be */
        if (*k_ani > K_ANI3) {
            GP142_circleXY(RED, x -K_EXP1, y - K_EXP4, K_EXP3);
            GP142_circleXY(RED, x +K_EXP1, y - K_EXP4, K_EXP3);
        }

    /*text after head explodes */
        if (*k_ani >= K_ANI4) {
            GP142_printfXY(RED, x - 3 * KENNYHEAD, y - 2 * KENNYBODY_Y, 
                KENNYFONT, "---YOU KILLED KENNY, YOU BASTARD!!!");
        }

    /*DRAW the rest */
    /*Draw the body*/
    GP142_rectangleXY(RED, x - KENNYBODY_X, y - KENNYHEAD + KENNYHEAD_OFF,
        x + KENNYBODY_X, y - KENNYHEAD + KENNYHEAD_OFF - KENNYBODY_Y, FILL);
    GP142_lineXY(BLACK, x, y - KENNYHEAD, x, 
        y - KENNYHEAD + KENNYHEAD_OFF - KENNYBODY_Y, 1);
    GP142_rectangleXY(BLACK, x - KENNYBODY_X - KENNYBODY_OFF, 
        y - KENNYHEAD + KENNYHEAD_OFF - KENNYBODY_Y, x + KENNYBODY_X +
        KENNYBODY_OFF, y - KENNYHEAD + KENNYHEAD_OFF - KENNYBODY_Y -
        KENNYBODY_OFF, FILL);

    /*Draw arms and hands */
    GP142_circleXY (BROWN, x - KENNYBODY_X - (KENNYARM /2) -1 , 
        y - KENNYHEAD + KENNYHEAD_OFF - ( KENNYBODY_Y / 2) - KENNYARM_Y - KENNYHAND_Y,
        KENNYHAND);
    GP142_circleXY (BROWN, x + KENNYBODY_X + (KENNYARM /2) +1 , 
        y - KENNYHEAD + KENNYHEAD_OFF - ( KENNYBODY_Y / 2) - KENNYARM_Y - KENNYHAND_Y,
        KENNYHAND);
    GP142_triangleXY (RED, x - KENNYBODY_X, y - KENNYHEAD + KENNYHEAD_OFF, 
        x - KENNYBODY_X, 
        y - KENNYHEAD + KENNYHEAD_OFF - ( KENNYBODY_Y / 2) - KENNYARM_Y,
        x - KENNYBODY_X - KENNYARM, 
        y - KENNYHEAD + KENNYHEAD_OFF - ( KENNYBODY_Y / 2) - KENNYARM_Y, FILL);
    GP142_triangleXY (RED, x + KENNYBODY_X, y - KENNYHEAD + KENNYHEAD_OFF, 
        x + KENNYBODY_X, 
        y - KENNYHEAD + KENNYHEAD_OFF - ( KENNYBODY_Y / 2) - KENNYARM_Y,
        x + KENNYBODY_X + KENNYARM, 
        y - KENNYHEAD + KENNYHEAD_OFF - ( KENNYBODY_Y / 2) - KENNYARM_Y, FILL);
    GP142_lineXY (BLACK, x - KENNYBODY_X, y - KENNYHEAD, x - KENNYBODY_X,
        y - KENNYHEAD + KENNYHEAD_OFF - ( KENNYBODY_Y / 2) - KENNYARM_Y - 1 , 1);
    GP142_lineXY (BLACK, x + KENNYBODY_X, y - KENNYHEAD, x + KENNYBODY_X,
        y - KENNYHEAD + KENNYHEAD_OFF - ( KENNYBODY_Y / 2) - KENNYARM_Y - 1 , 1);

    /*Draw his belt */
    GP142_rectangleXY (BROWN, x - KENNYBODY_X, 
        y - KENNYHEAD + KENNYHEAD_OFF - (KENNYBODY_Y / 2) - (KENNYBELT/2), 
        x + KENNYBODY_X, 
        y - KENNYHEAD + KENNYHEAD_OFF - (KENNYBODY_Y / 2) - (3*KENNYBELT/2), FILL);
    
    return; /* return here so that the next stuff is skipped */
    }


    /*FOLLOWING HERE:  Kenny is still intact */
    /*draw the head*/
    GP142_circleXY(RED, x+c, y+d, KENNYHEAD);
    GP142_circleXY(BROWN, x+c, y+d, KENNYHEAD1);
    GP142_ovalXY(PEACH, x +c- KENNYHEAD_X, y +d+ KENNYHEAD_Y, x +c+ KENNYHEAD_X,
        y +d- KENNYHEAD_Y, FILL );
    GP142_circleXY(WHITE + exp_col, x+c - KENNYEYE_X, y +d+ KENNYEYE_Y, KENNYEYE);
    GP142_circleXY(WHITE + exp_col, x+c + KENNYEYE_X, y +d+ KENNYEYE_Y, KENNYEYE);

    
    GP142_circleXY(BLACK, x - KENNYEYE_X+c, y + KENNYEYE_Y+d, KENNYPUPIL);
    GP142_circleXY(BLACK, x + KENNYEYE_X+c, y + KENNYEYE_Y+d, KENNYPUPIL);

    /*Draw the body*/
    GP142_rectangleXY(RED, x - KENNYBODY_X, y - KENNYHEAD + KENNYHEAD_OFF,
        x + KENNYBODY_X, y - KENNYHEAD + KENNYHEAD_OFF - KENNYBODY_Y, FILL);
    GP142_lineXY(BLACK, x, y - KENNYHEAD, x, 
        y - KENNYHEAD + KENNYHEAD_OFF - KENNYBODY_Y, 1);
    GP142_rectangleXY(BLACK, x - KENNYBODY_X - KENNYBODY_OFF, 
        y - KENNYHEAD + KENNYHEAD_OFF - KENNYBODY_Y, x + KENNYBODY_X +
        KENNYBODY_OFF, y - KENNYHEAD + KENNYHEAD_OFF - KENNYBODY_Y -
        KENNYBODY_OFF, FILL);

    /*Draw arms and hands */
    GP142_circleXY (BROWN, x - KENNYBODY_X - (KENNYARM /2) -1 , 
        y - KENNYHEAD + KENNYHEAD_OFF - ( KENNYBODY_Y / 2) - KENNYARM_Y - KENNYHAND_Y,
        KENNYHAND);
    GP142_circleXY (BROWN, x + KENNYBODY_X + (KENNYARM /2) +1 , 
        y - KENNYHEAD + KENNYHEAD_OFF - ( KENNYBODY_Y / 2) - KENNYARM_Y - KENNYHAND_Y,
        KENNYHAND);
    GP142_triangleXY (RED, x - KENNYBODY_X, y - KENNYHEAD + KENNYHEAD_OFF, 
        x - KENNYBODY_X, 
        y - KENNYHEAD + KENNYHEAD_OFF - ( KENNYBODY_Y / 2) - KENNYARM_Y,
        x - KENNYBODY_X - KENNYARM, 
        y - KENNYHEAD + KENNYHEAD_OFF - ( KENNYBODY_Y / 2) - KENNYARM_Y, FILL);
    GP142_triangleXY (RED, x + KENNYBODY_X, y - KENNYHEAD + KENNYHEAD_OFF, 
        x + KENNYBODY_X, 
        y - KENNYHEAD + KENNYHEAD_OFF - ( KENNYBODY_Y / 2) - KENNYARM_Y,
        x + KENNYBODY_X + KENNYARM, 
        y - KENNYHEAD + KENNYHEAD_OFF - ( KENNYBODY_Y / 2) - KENNYARM_Y, FILL);
    GP142_lineXY (BLACK, x - KENNYBODY_X, y - KENNYHEAD, x - KENNYBODY_X,
        y - KENNYHEAD + KENNYHEAD_OFF - ( KENNYBODY_Y / 2) - KENNYARM_Y - 1 , 1);
    GP142_lineXY (BLACK, x + KENNYBODY_X, y - KENNYHEAD, x + KENNYBODY_X,
        y - KENNYHEAD + KENNYHEAD_OFF - ( KENNYBODY_Y / 2) - KENNYARM_Y - 1 , 1);

    /*Draw his belt */
    GP142_rectangleXY (BROWN, x - KENNYBODY_X, 
        y - KENNYHEAD + KENNYHEAD_OFF - (KENNYBODY_Y / 2) - (KENNYBELT/2), 
        x + KENNYBODY_X, 
        y - KENNYHEAD + KENNYHEAD_OFF - (KENNYBODY_Y / 2) - (3*KENNYBELT/2), FILL);
    
    
    }

}

/**********************************************************************
 * Mouse clicks occur in one of three regions of interest: on buttons, 
 * on the card, or anywhere else.
 */
int  ClassifyMouseClick(int mouse_x, int mouse_y)
{
  if ((mouse_x < -GP142_XMAX + BUTTON_WIDTH) &&
      (mouse_y < GP142_YMAX) &&
      (mouse_y > (GP142_YMAX - NUM_BUTTONS*BUTTON_HEIGHT)))
    return CLICK_BUTTON;
  else if (mouse_x >= PAGE_LLX && mouse_x < PAGE_LLX + PAGE_WIDTH
      && mouse_y >= PAGE_LLY && mouse_y < PAGE_LLY + PAGE_HEIGHT)
    return CLICK_CARD;
  else
    return CLICK_OUTSIDE;

}


/**********************************************************************
 * Decide where a mouse click occured, and react appropriately.
 */
void HandleMouseClick(int mouse_x, int mouse_y, int *background_color, 
                      int *status, int *object_count, int *object_type, 
                      int *object_num, int *object_color, 
                      int *object_x, int *object_y, int obj_x[MAX_OBJ],
                      int obj_y[MAX_OBJ], int obj_color[MAX_OBJ],
                      int obj_type[MAX_OBJ], int obj_spec[MAX_OBJ],
                      int *last_button, int *border_color)
{

    int mouse_click;
    mouse_click = ClassifyMouseClick(mouse_x, mouse_y);
            
    if (mouse_click == CLICK_BUTTON) {
                
        /* A button has been clicked.  Call a function to handle it*/
        /* most of the variables passed as args will NOT change*/
        HandleButton(mouse_x, mouse_y, background_color, status, 
                     *object_count, *object_type, object_num, object_color,
                     obj_x, obj_y, obj_color, obj_type, obj_spec, last_button, 
                     border_color);

    } else if (mouse_click == CLICK_CARD) {
        /* Add a shape, if there isn't one already */
        AddShape(mouse_x, mouse_y, status, object_count, 
               object_type, object_num, object_color, 
               object_x, object_y, obj_x, obj_y, obj_color, obj_type,
               obj_spec);
    }
    /* Ignore any other mouse clicks */
}

/********************************************************************** 
 * Figure out which button was clicked, if any, and do the right 
 * thing.
 */
void HandleButton(int x, int y, int *background_color, int *status,
                  int object_count, int object_type, int *object_num, int *object_color,
                  int obj_x[MAX_OBJ], int obj_y[MAX_OBJ], int obj_color[MAX_OBJ],
                  int obj_type[MAX_OBJ], int obj_spec[MAX_OBJ], int *last_button, 
                  int *border_color)
{
    int buttonNum = 0;
    char inst[400] = {"Press a button at the left, and click on "
        "the screen, help is below workspace. "};

    char dummy[100];
    
    /* If we're outside of this area, we could not have clicked on
    * a button.
    */
    if (x > -GP142_XMAX + BUTTON_WIDTH)  
        return ;    /*That's an error situation*/
    
                    /* We know the mouse clicked in the column of buttons. Calculate
                    * which one.
    */
    buttonNum = (GP142_YMAX - y)/BUTTON_HEIGHT;  
    
    switch(buttonNum) {
    case 0:
        /* Change the background color */
        *background_color = (*background_color + 1) % MAX_COLORS;
        *last_button = 0;
        break;
    case 1:
        /* Change the type of the currently selected object */
        if ((object_count >= 1) && (object_type == OBJECT_SHAPE)){
            *object_num = (*object_num + 1) % MAX_SHAPES;
            obj_type[object_count] = OBJECT_SHAPE;
            obj_spec[object_count] = *object_num;
            *last_button = 1;
        }
        if ((object_count >= 1) && (object_type == OBJECT_MESSAGE)){
            *object_num = (*object_num + 1) % MAX_MESSAGES;
            obj_type[object_count] = OBJECT_MESSAGE;
            obj_spec[object_count] = *object_num;
            *last_button = 1;
        }
        break;
    case 2:
        /* change the object color*/
        *object_color = (*object_color +1) % MAX_COLORS;
        obj_color[object_count] = *object_color;
        *last_button = 2;
        break;
    case 3:
        /* add a message */
        *status = STATUS_ADD_MESSAGE;
        *last_button = 3;
        break;
    case 4:
        /* add a shape */
        if (object_count < MAX_OBJ-1){
        *status = STATUS_ADD_SHAPE; 
        *last_button = 4;
        }
        break;
    case 5:
        /* select an object from the screen */
        *status = STATUS_SELECTING;
        *last_button = 5;
        break;
    case 6:
        /* Clear the page */
        *status = STATUS_CLEAR;
        *last_button = 6;
        break;
    case 7:
        /* Change the outside border color */
        *border_color = (*border_color + 1) % MAX_COLORS;
        *last_button = 7;
        break;
    case 8:
        /* Give the user instructions */
        GP142_gets(inst, dummy);
        *last_button = 8;
        break;
    default:
        *status = 999;
        /*Bad news if this is ever reached! */
        break;
    }
}

/*********************************************************************
** If there's room for another shape, add it to the card. */
void AddShape(int x, int y, int *status, int *object_count, 
               int *object_type, int *object_num, int *object_color, 
               int *object_x, int *object_y, int obj_x[MAX_OBJ], 
               int obj_y[MAX_OBJ], int obj_color[MAX_OBJ],
               int obj_type[MAX_OBJ], int obj_spec[MAX_OBJ])


{
    /*local var*/
    int z;
        
    if (*object_count == 0) {
        *status = STATUS_SELECTED;
        *object_count = 1;
        *object_type = OBJECT_SHAPE;
        *object_num = SHAPE_HEART;
        *object_color = BLACK;
        *object_x = x;
        *object_y = y;
        obj_x[*object_count] = x;   /* set the array values */
        obj_y[*object_count] = y;
        obj_color[*object_count] = *object_color;
        obj_type[*object_count] = *object_type;
        obj_spec[*object_count] = *object_num;
        return;
    }
    if (*status == STATUS_SELECTED) {
        *object_type = obj_type[*object_count];  /*read from array values*/
        *object_num = obj_spec[*object_count];
        *object_color = obj_color[*object_count];
        *object_x = x;
        *object_y = y;
        obj_x[*object_count] = x;  /*store new position in array */
        obj_y[*object_count] = y;

    }
    if (*status == STATUS_ADD_SHAPE) {
        (*object_count)++;
        *object_type = OBJECT_SHAPE;  /* start with new shape*/
        *object_num = SHAPE_HEART;
        *object_color = BLACK;
        *object_x = x;
        *object_y = y;
        obj_x[*object_count] = x;
        obj_y[*object_count] = y;
        obj_color[*object_count] = *object_color;
        obj_type[*object_count] = *object_type;
        obj_spec[*object_count] = *object_num;
        *status = STATUS_SELECTED;
    }

    if (*status == STATUS_ADD_MESSAGE){
        (*object_count)++;
        *object_type = OBJECT_MESSAGE;
        *object_num = MESS_0;
        *object_color = BLACK;
        *object_x = x;
        *object_y = y;
        obj_x[*object_count] = x;
        obj_y[*object_count] = y;
        obj_color[*object_count] = *object_color;
        obj_type[*object_count] = *object_type;
        obj_spec[*object_count] = *object_num;
        *status = STATUS_SELECTED;
    }
    if (*status == STATUS_SELECTING) {      
        /*return what object is closest*/
        z = CheckClose(x, y, obj_x, obj_y, object_count);  /*returns 0 if none */
        if (z != 0) {
            if (z != *object_count)  /*make the selected object the active one */
                swap_arr(z, obj_x, obj_y, obj_color, obj_type, obj_spec, object_count);

            *object_type = obj_type[*object_count];  /*find out the type */
            *object_num = obj_spec[*object_count];   /* what shape/message */
            *object_color = obj_color[*object_count]; /* selected object's color*/
            *object_x = obj_x[*object_count];   /* selected object's position */
            *object_y = obj_y[*object_count];   /* same */
            *status = STATUS_SELECTED;
        }
    }

    if (*status == STATUS_CLEAR) {
        *object_count = 0; /* go back to no objects */
        *status = STATUS_ADD_SHAPE; /* default value */
    }

}



/**********************************************************************
 * DrawMessage
 *
 * Output a message
 */

void DrawMessage(int spec, int color, int x, int y){
    int j, fontsize = 14;
    j = rand() % MESS_CNST;
    
    switch (spec) {
    case MESS_0:
        GP142_printfXY (color, x, y, fontsize - j, "Happy Valentine's Day!");
        break;
    case MESS_1:
        GP142_printfXY (color, x, y, fontsize - j, "Your's Truely");
        break;
    case MESS_2:
        GP142_printfXY (color, x, y, fontsize - j, "B - MINE");
        break;
    case MESS_3:
        GP142_printfXY (color, x, y, fontsize - j, "LUV-U");
        break;
    case MESS_4:
        GP142_printfXY (color, x, y, fontsize - j, "Play that funky music...");
        break;
    case MESS_5:
        GP142_printfXY (color, x, y, fontsize - j, "It's a Love Bug!");
        break;
    default:
        /*you have a problem */
        break;
    }

}


/**********************************************************************
 * CheckClose
 *
 * Determines which shape, if any is closest to where the user clicks
 * Shape (center) must be with in 15 pixels of where the user clicks
 *
 */

int CheckClose (int x, int y, int xa[MAX_OBJ], int ya[MAX_OBJ], int *object_count)
{
    int close_i=0, i; /*local variables*/
    double temp_c = 0.0, close= CLOSENESS + 1.0;

    /* check the distances */
    for (i = 1; i <= *object_count; i++){
        temp_c = sqrt(((x - xa[i]) * (x - xa[i])) + ((y - ya[i]) * (y - ya[i])));
        if ( temp_c <= CLOSENESS) {  /*is the distance below the max dist */
            if (temp_c < close) {    /*is it the closest distance yet? */
                close = temp_c;
                close_i = i;
            }
        }
    }
    if (close_i == 0)
        return 0;
    else 
        return close_i;
}

/**********************************************************************
 * swap_arr
 *
 * Swaps the array values for the selected object
 */
void swap_arr(int x, int obj_x[MAX_OBJ], int obj_y[MAX_OBJ], int obj_color[MAX_OBJ], 
              int obj_type[MAX_OBJ], int obj_spec[MAX_OBJ], int *object_count)
{
    /* local variables */
    int temp_x, temp_y, temp_color, temp_type, temp_spec;

    /*assigns the selected object attributes into temp values*/
    temp_x = obj_x[x];
    temp_y = obj_y[x];
    temp_color = obj_color[x];
    temp_type = obj_type[x];
    temp_spec = obj_spec[x];
    
    /*stores the values of the formerly active object into the areas where
    the newly selected objects values were */
    obj_x[x] = obj_x[*object_count];
    obj_y[x] = obj_y[*object_count];
    obj_color[x] = obj_color[*object_count];
    obj_type[x] = obj_type[*object_count];
    obj_spec[x] = obj_spec[*object_count];

    /*puts the selected objects values into the active area */
    obj_x[*object_count] = temp_x;
    obj_y[*object_count] = temp_y;
    obj_color[*object_count] = temp_color;
    obj_type[*object_count] = temp_type;
    obj_spec[*object_count] = temp_spec;

}
